diff --git a/src/main/java/net/minecraft/core/item/ItemMap.java b/game/core/src/main/java/net/minecraft/core/item/ItemMap.java
similarity index 96%
rename from src/main/java/net/minecraft/core/item/ItemMap.java
rename to game/core/src/main/java/net/minecraft/core/item/ItemMap.java
index eb0789e3b..044790b29 100644
--- a/src/main/java/net/minecraft/core/item/ItemMap.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemMap.java
@@ -7,7 +7,7 @@ import net.minecraft.core.block.material.Material;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.lang.I18n;
-import net.minecraft.core.net.packet.MapDataPacket;
+import net.minecraft.core.net.packet.PacketMapData;
 import net.minecraft.core.net.packet.Packet;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.util.helper.Side;
@@ -218,16 +218,16 @@ public class ItemMap extends Item implements IComplexItem
 								do {
 									runLoop = false;
 									id = chunk.getBlockID(_x + blockInChunkX, height, _z + blockInChunkZ);
-									if(id <= 0 || (height > 0 && Block.blocksList[id].blockMaterial.color == MaterialColor.none)) {
+									if(id <= 0 || (height > 0 && Blocks.blocksList[id].blockMaterial.color == MaterialColor.none)) {
 										runLoop = true;
 										height--;
 									}
 								} while (runLoop);
-								if(Block.blocksList[id].blockMaterial == Material.water) {
+								if(Blocks.blocksList[id].blockMaterial == Material.water) {
 									int _y = height;
                                     int _blockID = chunk.getBlockID(_x + blockInChunkX, _y--, _z + blockInChunkZ);
                                     waterDepth++;
-                                    while (_y > 0 && _blockID > 0 && Block.blocksList[_blockID].blockMaterial == Material.water) {
+                                    while (_y > 0 && _blockID > 0 && Blocks.blocksList[_blockID].blockMaterial == Material.water) {
                                         _blockID = chunk.getBlockID(_x + blockInChunkX, _y--, _z + blockInChunkZ);
                                         waterDepth++;
                                     }
@@ -270,7 +270,7 @@ public class ItemMap extends Item implements IComplexItem
 				
 				int colorIndex = 0;
 				if(id > 0) {
-					MaterialColor mapcolor = Block.blocksList[id].blockMaterial.color;
+					MaterialColor mapcolor = Blocks.blocksList[id].blockMaterial.color;
 					if(mapcolor == MaterialColor.water) {
 						double d3 = (double) waterDepth * 0.1D + (double) (x + z & 1) * 0.2D;
 						brightness = 1;
@@ -281,7 +281,7 @@ public class ItemMap extends Item implements IComplexItem
 							brightness = 0;
 						}
 					}
-					colorIndex = MaterialColor.getColorIndexFromBlock(Block.blocksList[id], meta);
+					colorIndex = MaterialColor.getColorIndexFromBlock(Blocks.blocksList[id], meta);
 				}
 				previousPixelHeight = pixelHeight;
 				if(!previousChunkLoaded) {
@@ -367,7 +367,7 @@ public class ItemMap extends Item implements IComplexItem
 				return null;
 			} else
 			{
-				return new MapDataPacket((short)Items.MAP.id, (short)itemstack.getMetadata(), getScale(itemstack), mapDataBytes, itemMapSavedData.mapWaypoints);
+				return new PacketMapData((short)Items.MAP.id, (short)itemstack.getMetadata(), getScale(itemstack), mapDataBytes, itemMapSavedData.mapWaypoints);
 			}
 		}
 		return null;
diff --git a/src/main/java/net/minecraft/core/item/ItemPaintBrush.java b/game/core/src/main/java/net/minecraft/core/item/ItemPaintBrush.java
similarity index 98%
rename from src/main/java/net/minecraft/core/item/ItemPaintBrush.java
rename to game/core/src/main/java/net/minecraft/core/item/ItemPaintBrush.java
index 5a2468b75..79d9dac51 100644
--- a/src/main/java/net/minecraft/core/item/ItemPaintBrush.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemPaintBrush.java
@@ -2,6 +2,7 @@ package net.minecraft.core.item;
 
 import com.mojang.nbt.CompoundTag;
 import net.minecraft.core.block.Block;
+import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.IPaintable;
 import net.minecraft.core.block.IPainted;
 import net.minecraft.core.block.entity.TileEntityActivator;
@@ -31,7 +32,7 @@ public class ItemPaintBrush extends Item {
         }
 
         final int id = world.getBlockId(blockX, blockY, blockZ);
-        final Block block = Block.getBlock(id);
+        final Block block = Blocks.getBlock(id);
 
         if (block instanceof IPaintable) {
             final IPaintable paintable = (IPaintable) block;
diff --git a/src/main/java/net/minecraft/core/item/ItemPebble.java b/game/core/src/main/java/net/minecraft/core/item/ItemPebble.java
similarity index 97%
rename from src/main/java/net/minecraft/core/item/ItemPebble.java
rename to game/core/src/main/java/net/minecraft/core/item/ItemPebble.java
index 4fa0a2ffa..db97cf0ad 100644
--- a/src/main/java/net/minecraft/core/item/ItemPebble.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemPebble.java
@@ -42,7 +42,7 @@ public class ItemPebble extends Item implements IDispensable
     {
         int id = world.getBlockId(blockX, blockY, blockZ);
         int meta = world.getBlockMetadata(blockX, blockY, blockZ);
-        if (id != Blocks.OVERLAY_PEBBLES.id && Block.blocksList[id] != null && Block.blocksList[id].hasTag(BlockTags.PLACE_OVERWRITES))
+        if (id != Blocks.OVERLAY_PEBBLES.id && Blocks.blocksList[id] != null && Blocks.blocksList[id].hasTag(BlockTags.PLACE_OVERWRITES))
         {
             id = 0;
             meta = 0;
diff --git a/src/main/java/net/minecraft/core/item/ItemSeeds.java b/game/core/src/main/java/net/minecraft/core/item/ItemSeeds.java
similarity index 95%
rename from src/main/java/net/minecraft/core/item/ItemSeeds.java
rename to game/core/src/main/java/net/minecraft/core/item/ItemSeeds.java
index 981f2392a..b40949425 100644
--- a/src/main/java/net/minecraft/core/item/ItemSeeds.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemSeeds.java
@@ -30,7 +30,7 @@ public class ItemSeeds extends Item {
 		}
 		if(world.getBlockId(blockX, blockY - 1, blockZ) == Blocks.FARMLAND_DIRT.id && world.canPlaceInsideBlock(blockX, blockY, blockZ)) {
 			if(world.setBlockWithNotify(blockX, blockY, blockZ, cropsId)) {
-				world.playBlockSoundEffect(entityplayer, blockX + 0.5F, blockY + 0.5F, blockZ + 0.5F, Block.blocksList[cropsId], EnumBlockSoundEffectType.PLACE);
+				world.playBlockSoundEffect(entityplayer, blockX + 0.5F, blockY + 0.5F, blockZ + 0.5F, Blocks.blocksList[cropsId], EnumBlockSoundEffectType.PLACE);
 				itemstack.consumeItem(entityplayer);
 				return true;
 			}
diff --git a/src/main/java/net/minecraft/core/item/ItemStack.java b/game/core/src/main/java/net/minecraft/core/item/ItemStack.java
similarity index 99%
rename from src/main/java/net/minecraft/core/item/ItemStack.java
rename to game/core/src/main/java/net/minecraft/core/item/ItemStack.java
index 8cd3acf39..f62dbcf25 100644
--- a/src/main/java/net/minecraft/core/item/ItemStack.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemStack.java
@@ -161,10 +161,10 @@ public final class ItemStack {
 		int version = nbt.getInteger("Version");
 		
 		if(expanded == 0 && itemID >= 256) {
-			itemID += (Block.blocksList.length - 256);
+			itemID += (Blocks.blocksList.length - 256);
 		}
 		
-		if(version < 19133 && itemID < Block.blocksList.length) {
+		if(version < 19133 && itemID < Blocks.blocksList.length) {
 			short[] id = new short[] { (short) itemID };
 			byte[] meta = new byte[] { (byte) metadata };
 			ChunkConverter.converters[0].convertBlocksAndMetadata(id, meta);
diff --git a/src/main/java/net/minecraft/core/item/Items.java b/game/core/src/main/java/net/minecraft/core/item/Items.java
similarity index 99%
rename from src/main/java/net/minecraft/core/item/Items.java
rename to game/core/src/main/java/net/minecraft/core/item/Items.java
index a2398ec2e..e4a528f69 100644
--- a/src/main/java/net/minecraft/core/item/Items.java
+++ b/game/core/src/main/java/net/minecraft/core/item/Items.java
@@ -201,13 +201,13 @@ public final class Items {
         for (int i = 0; i < Item.itemsList.length; i++) {
             Item item = Item.getItem(i);
             if (item == null) continue;
-            if (i < Block.blocksList.length && !Block.getBlock(i).getEnableStats()){
+            if (i < Blocks.blocksList.length && !Blocks.getBlock(i).getEnableStats()){
                 continue;
             }
 
             item.createStat(StatList.STAT_PICKED_UP, "");
             Stat used = item.createStat(StatList.STAT_USED, "stat.useItem");
-            if (i >= Block.blocksList.length){
+            if (i >= Blocks.blocksList.length){
                 StatList.usedItemStats.add(used);
             }
 
@@ -215,7 +215,7 @@ public final class Items {
                 item.createStat(StatList.STAT_DEPLETED, "stat.breakItem");
             }
 
-            if (i < Block.blocksList.length){
+            if (i < Blocks.blocksList.length){
                 item.createStat(StatList.STAT_MINED, "stat.mineBlock");
             }
         }
diff --git a/src/main/java/net/minecraft/core/item/block/ItemBlock.java b/game/core/src/main/java/net/minecraft/core/item/block/ItemBlock.java
similarity index 88%
rename from src/main/java/net/minecraft/core/item/block/ItemBlock.java
rename to game/core/src/main/java/net/minecraft/core/item/block/ItemBlock.java
index d632fb62b..fec0178f8 100644
--- a/src/main/java/net/minecraft/core/item/block/ItemBlock.java
+++ b/game/core/src/main/java/net/minecraft/core/item/block/ItemBlock.java
@@ -1,6 +1,7 @@
 package net.minecraft.core.item.block;
 
 import net.minecraft.core.block.Block;
+import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.entity.TileEntityActivator;
 import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.entity.player.Player;
@@ -28,7 +29,7 @@ public class ItemBlock extends Item
 
     public Block getBlock()
     {
-        return Block.blocksList[blockID];
+        return Blocks.blocksList[blockID];
     }
 
     @Override
@@ -45,7 +46,7 @@ public class ItemBlock extends Item
 			return false;
 		}
 		if(world.canBlockBePlacedAt(blockID, x, y, z, false, side)) {
-			Block block = Block.blocksList[blockID];
+			Block block = Blocks.blocksList[blockID];
 			int meta = getPlacedBlockMetadata(player, stack, world, x, y, z, side, xPlaced, yPlaced);
 			if(world.setBlockAndMetadataWithNotify(x, y, z, blockID, meta)) {
 				stack.consumeItem(player);
@@ -74,18 +75,18 @@ public class ItemBlock extends Item
 
     public int getPlacedBlockMetadata(@Nullable Player player, ItemStack stack, World world, int x, int y, int z, Side side, double xPlaced, double yPlaced)
     {
-    	return Block.getBlock(blockID).getPlacedBlockMetadata(player, stack, world, x, y, z, side, xPlaced, yPlaced);
+    	return Blocks.getBlock(blockID).getPlacedBlockMetadata(player, stack, world, x, y, z, side, xPlaced, yPlaced);
     }
 
     @Override
     public String getLanguageKey(ItemStack itemstack)
     {
-        return Block.blocksList[blockID].getLanguageKey(itemstack.getMetadata());
+        return Blocks.blocksList[blockID].getLanguageKey(itemstack.getMetadata());
     }
 
     @Override
     public String getKey()
     {
-        return Block.blocksList[blockID].getKey();
+        return Blocks.blocksList[blockID].getKey();
     }
 }
diff --git a/src/main/java/net/minecraft/core/item/block/ItemBlockAlgae.java b/game/core/src/main/java/net/minecraft/core/item/block/ItemBlockAlgae.java
similarity index 95%
rename from src/main/java/net/minecraft/core/item/block/ItemBlockAlgae.java
rename to game/core/src/main/java/net/minecraft/core/item/block/ItemBlockAlgae.java
index da9cb36ee..cf75bd63c 100644
--- a/src/main/java/net/minecraft/core/item/block/ItemBlockAlgae.java
+++ b/game/core/src/main/java/net/minecraft/core/item/block/ItemBlockAlgae.java
@@ -73,10 +73,10 @@ public class ItemBlockAlgae extends ItemBlock
 
             if(world.getBlockId(blockX, blockY, blockZ) != 0)
                 return itemstack;
-            Block block = Block.blocksList[Blocks.ALGAE.id];
+            Block block = Blocks.blocksList[Blocks.ALGAE.id];
             if(itemstack.consumeItem(player) && world.setBlockAndMetadataWithNotify(blockX, blockY, blockZ, Blocks.ALGAE.id, 0))
             {
-                Block.blocksList[blockID].onBlockPlacedByMob(world, blockX, blockY, blockZ, Side.NONE, player, 0.5, 0.5);
+                Blocks.blocksList[blockID].onBlockPlacedByMob(world, blockX, blockY, blockZ, Side.NONE, player, 0.5, 0.5);
                 world.playBlockSoundEffect(player, blockX + 0.5F, blockY + 0.5F, blockZ + 0.5F, block, EnumBlockSoundEffectType.PLACE);
                 player.swingItem();
             }
diff --git a/src/main/java/net/minecraft/core/item/block/ItemBlockLadder.java b/game/core/src/main/java/net/minecraft/core/item/block/ItemBlockLadder.java
similarity index 94%
rename from src/main/java/net/minecraft/core/item/block/ItemBlockLadder.java
rename to game/core/src/main/java/net/minecraft/core/item/block/ItemBlockLadder.java
index 241346bb3..f9920881b 100644
--- a/src/main/java/net/minecraft/core/item/block/ItemBlockLadder.java
+++ b/game/core/src/main/java/net/minecraft/core/item/block/ItemBlockLadder.java
@@ -2,6 +2,7 @@ package net.minecraft.core.item.block;
 
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLadder;
+import net.minecraft.core.block.Blocks;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumBlockSoundEffectType;
 import net.minecraft.core.item.ItemStack;
@@ -56,7 +57,7 @@ public class ItemBlockLadder extends ItemBlock {
 	public boolean placeBlock(World world, int x, int y, int z, int meta, @Nullable Player player, ItemStack stack, Side side, double xPlaced, double yPlaced) {
 		if(world.canPlaceInsideBlock(x, y, z) && world.canBlockBePlacedAt(blockID, x, y, z, false, side) && stack.consumeItem(player)) {
 			if(world.setBlockAndMetadataWithNotify(x, y, z, blockID, meta)) {
-				Block.getBlock(blockID).onBlockPlacedByMob(world, x, y, z, side, player, xPlaced, yPlaced);
+				Blocks.getBlock(blockID).onBlockPlacedByMob(world, x, y, z, side, player, xPlaced, yPlaced);
 				world.playBlockSoundEffect(player, x + 0.5f, y + 0.5f, z + 0.5f, ladderBlock, EnumBlockSoundEffectType.PLACE);
 				return true;
 			}
diff --git a/src/main/java/net/minecraft/core/item/block/ItemBlockLayer.java b/game/core/src/main/java/net/minecraft/core/item/block/ItemBlockLayer.java
similarity index 84%
rename from src/main/java/net/minecraft/core/item/block/ItemBlockLayer.java
rename to game/core/src/main/java/net/minecraft/core/item/block/ItemBlockLayer.java
index 1692cfbf4..38c9c089e 100644
--- a/src/main/java/net/minecraft/core/item/block/ItemBlockLayer.java
+++ b/game/core/src/main/java/net/minecraft/core/item/block/ItemBlockLayer.java
@@ -2,6 +2,7 @@ package net.minecraft.core.item.block;
 
 import net.minecraft.core.block.BlockLayerBase;
 import net.minecraft.core.block.Block;
+import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumBlockSoundEffectType;
@@ -24,7 +25,7 @@ public class ItemBlockLayer extends ItemBlock
 	{
 		int id = world.getBlockId(blockX, blockY, blockZ);
 		int meta = world.getBlockMetadata(blockX, blockY, blockZ);
-		if (id != blockID && Block.blocksList[id] != null && Block.blocksList[id].hasTag(BlockTags.PLACE_OVERWRITES))
+		if (id != blockID && Blocks.blocksList[id] != null && Blocks.blocksList[id].hasTag(BlockTags.PLACE_OVERWRITES))
 		{
 			id = 0;
 			meta = 0;
@@ -33,7 +34,7 @@ public class ItemBlockLayer extends ItemBlock
 		{
 			return false;
 		}
-		if (blockY == world.getHeightBlocks() - 1 && Block.blocksList[blockID].blockMaterial.isSolid())
+		if (blockY == world.getHeightBlocks() - 1 && Blocks.blocksList[blockID].blockMaterial.isSolid())
 		{
 			return false;
 		}
@@ -42,7 +43,7 @@ public class ItemBlockLayer extends ItemBlock
 		if (id == blockID && side == Side.TOP)
 		{
 
-			final BlockLayerBase blockLayer = (BlockLayerBase) Block.blocksList[blockID];
+			final BlockLayerBase blockLayer = (BlockLayerBase) Blocks.blocksList[blockID];
 
 			final int newMeta = meta + 1;
 
@@ -87,7 +88,7 @@ public class ItemBlockLayer extends ItemBlock
 		if (id == blockID)
 		{
 
-			final BlockLayerBase blockLayer = (BlockLayerBase) Block.blocksList[blockID];
+			final BlockLayerBase blockLayer = (BlockLayerBase) Blocks.blocksList[blockID];
 
 			final int newMeta = meta + 1;
 
@@ -120,14 +121,14 @@ public class ItemBlockLayer extends ItemBlock
 		// Regular placement, as all else fails
 		if (world.canBlockBePlacedAt(blockID, blockX, blockY, blockZ, false, side))
 		{
-			final Block block = Block.blocksList[blockID];
+			final Block block = Blocks.blocksList[blockID];
 			int placeMeta = getPlacedBlockMetadata(player, itemstack, world, blockX, blockY, blockZ, side, xPlaced, yPlaced);
 			if (world.setBlockAndMetadataWithNotify(blockX, blockY, blockZ, blockID, placeMeta))
 			{
 				if (player == null) {
-					Block.blocksList[blockID].onBlockPlacedOnSide(world, blockX, blockY, blockZ, side, xPlaced, yPlaced);
+					Blocks.blocksList[blockID].onBlockPlacedOnSide(world, blockX, blockY, blockZ, side, xPlaced, yPlaced);
 				} else {
-					Block.blocksList[blockID].onBlockPlacedByMob(world, blockX, blockY, blockZ, Side.NONE, player, xPlaced, yPlaced);
+					Blocks.blocksList[blockID].onBlockPlacedByMob(world, blockX, blockY, blockZ, Side.NONE, player, xPlaced, yPlaced);
 				}
 				world.playBlockSoundEffect(player, blockX + 0.5F, blockY + 0.5F, blockZ + 0.5F, block, EnumBlockSoundEffectType.PLACE);
 				itemstack.consumeItem(player);
diff --git a/src/main/java/net/minecraft/core/item/block/ItemBlockLayerLeaves.java b/game/core/src/main/java/net/minecraft/core/item/block/ItemBlockLayerLeaves.java
similarity index 85%
rename from src/main/java/net/minecraft/core/item/block/ItemBlockLayerLeaves.java
rename to game/core/src/main/java/net/minecraft/core/item/block/ItemBlockLayerLeaves.java
index 3a1342694..d189a96cc 100644
--- a/src/main/java/net/minecraft/core/item/block/ItemBlockLayerLeaves.java
+++ b/game/core/src/main/java/net/minecraft/core/item/block/ItemBlockLayerLeaves.java
@@ -4,6 +4,7 @@ import net.minecraft.core.block.BlockLayerBase;
 import net.minecraft.core.block.BlockLeavesBase;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLayerLeaves;
+import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumBlockSoundEffectType;
@@ -25,7 +26,7 @@ public class ItemBlockLayerLeaves extends ItemBlock
 	{
 		int id = world.getBlockId(blockX, blockY, blockZ);
 		int meta = world.getBlockMetadata(blockX, blockY, blockZ);
-		if (id != blockID && Block.blocksList[id] != null && Block.blocksList[id].hasTag(BlockTags.PLACE_OVERWRITES))
+		if (id != blockID && Blocks.blocksList[id] != null && Blocks.blocksList[id].hasTag(BlockTags.PLACE_OVERWRITES))
 		{
 			id = 0;
 			meta = 0;
@@ -34,7 +35,7 @@ public class ItemBlockLayerLeaves extends ItemBlock
 		{
 			return false;
 		}
-		if (blockY == world.getHeightBlocks() - 1 && Block.blocksList[blockID].blockMaterial.isSolid())
+		if (blockY == world.getHeightBlocks() - 1 && Blocks.blocksList[blockID].blockMaterial.isSolid())
 		{
 			return false;
 		}
@@ -43,7 +44,7 @@ public class ItemBlockLayerLeaves extends ItemBlock
 		if (id == blockID && side == Side.TOP)
 		{
 
-			final BlockLayerBase blockLayer = (BlockLayerBase) Block.blocksList[blockID];
+			final BlockLayerBase blockLayer = (BlockLayerBase) Blocks.blocksList[blockID];
 
 			final int newMeta = meta + 1;
 
@@ -88,7 +89,7 @@ public class ItemBlockLayerLeaves extends ItemBlock
 		if (id == blockID)
 		{
 
-			final BlockLayerBase blockLayer = (BlockLayerBase) Block.blocksList[blockID];
+			final BlockLayerBase blockLayer = (BlockLayerBase) Blocks.blocksList[blockID];
 
 			final int newMeta = meta + 1;
 
@@ -121,14 +122,14 @@ public class ItemBlockLayerLeaves extends ItemBlock
 		// Regular placement, as all else fails
 		if (world.canBlockBePlacedAt(blockID, blockX, blockY, blockZ, false, side))
 		{
-			final Block block = Block.blocksList[blockID];
+			final Block block = Blocks.blocksList[blockID];
 			int placeMeta = getPlacedBlockMetadata(player, itemstack, world, blockX, blockY, blockZ, side, xPlaced, yPlaced);
 			if (world.setBlockAndMetadataWithNotify(blockX, blockY, blockZ, blockID, placeMeta))
 			{
 				if (player == null) {
-					Block.blocksList[blockID].onBlockPlacedOnSide(world, blockX, blockY, blockZ, side, xPlaced, yPlaced);
+					Blocks.blocksList[blockID].onBlockPlacedOnSide(world, blockX, blockY, blockZ, side, xPlaced, yPlaced);
 				} else {
-					Block.blocksList[blockID].onBlockPlacedByMob(world, blockX, blockY, blockZ, side, player, xPlaced, yPlaced);
+					Blocks.blocksList[blockID].onBlockPlacedByMob(world, blockX, blockY, blockZ, side, player, xPlaced, yPlaced);
 				}
 				world.playBlockSoundEffect(player, blockX + 0.5F, blockY + 0.5F, blockZ + 0.5F, block, EnumBlockSoundEffectType.PLACE);
 				itemstack.consumeItem(player);
diff --git a/src/main/java/net/minecraft/core/item/block/ItemBlockSlab.java b/game/core/src/main/java/net/minecraft/core/item/block/ItemBlockSlab.java
similarity index 83%
rename from src/main/java/net/minecraft/core/item/block/ItemBlockSlab.java
rename to game/core/src/main/java/net/minecraft/core/item/block/ItemBlockSlab.java
index f6cddd9a9..a18eeac44 100644
--- a/src/main/java/net/minecraft/core/item/block/ItemBlockSlab.java
+++ b/game/core/src/main/java/net/minecraft/core/item/block/ItemBlockSlab.java
@@ -1,6 +1,7 @@
 package net.minecraft.core.item.block;
 
 import net.minecraft.core.block.Block;
+import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumBlockSoundEffectType;
@@ -24,7 +25,7 @@ public class ItemBlockSlab extends ItemBlock
     	int id = world.getBlockId(blockX, blockY, blockZ);
     	int meta = world.getBlockMetadata(blockX, blockY, blockZ) & 0x3;
     	int otherMeta = world.getBlockMetadata(blockX, blockY, blockZ) & ~0x3;
-    	if (Block.blocksList[world.getBlockId(blockX, blockY, blockZ)] != null && Block.blocksList[world.getBlockId(blockX, blockY, blockZ)].hasTag(BlockTags.PLACE_OVERWRITES))
+    	if (Blocks.blocksList[world.getBlockId(blockX, blockY, blockZ)] != null && Blocks.blocksList[world.getBlockId(blockX, blockY, blockZ)].hasTag(BlockTags.PLACE_OVERWRITES))
     	{
     		id = 0;
     		meta = 0;
@@ -33,7 +34,7 @@ public class ItemBlockSlab extends ItemBlock
         {
             return false;
         }
-        if(blockY == world.getHeightBlocks() - 1 && Block.blocksList[blockID].blockMaterial.isSolid())
+        if(blockY == world.getHeightBlocks() - 1 && Blocks.blocksList[blockID].blockMaterial.isSolid())
         {
             return false;
         }
@@ -47,7 +48,7 @@ public class ItemBlockSlab extends ItemBlock
                 if(!world.checkIfAABBIsClear(bbBox))
                     return false;
 
-        		Block blockSlab = Block.blocksList[blockID];
+        		Block blockSlab = Blocks.blocksList[blockID];
         		world.setBlockMetadataWithNotify(blockX, blockY, blockZ, 1 | itemstack.getMetadata());
                 world.playBlockSoundEffect(player, blockX + 0.5F, blockY + 0.5F, blockZ + 0.5F, blockSlab, EnumBlockSoundEffectType.PLACE);
             	itemstack.consumeItem(player);
@@ -75,7 +76,7 @@ public class ItemBlockSlab extends ItemBlock
                 if(!world.checkIfAABBIsClear(bbBox))
                     return false;
 
-        		Block blockSlab = Block.blocksList[blockID];
+        		Block blockSlab = Blocks.blocksList[blockID];
         		world.setBlockMetadataWithNotify(blockX, blockY, blockZ, 1 | itemstack.getMetadata());
                 world.playBlockSoundEffect(player, blockX + 0.5F, blockY + 0.5F, blockZ + 0.5F, blockSlab, EnumBlockSoundEffectType.PLACE);
                 itemstack.consumeItem(player);
@@ -86,14 +87,14 @@ public class ItemBlockSlab extends ItemBlock
         // Regular placement, as all else fails
         if(world.canBlockBePlacedAt(blockID, blockX, blockY, blockZ, false, side))
         {
-            Block block = Block.blocksList[blockID];
+            Block block = Blocks.blocksList[blockID];
             int placeMeta = getPlacedBlockMetadata(player, itemstack, world, blockX, blockY, blockZ, side, xPlaced, yPlaced);
             if(world.setBlockAndMetadataWithNotify(blockX, blockY, blockZ, blockID, placeMeta))
             {
                 if (player == null) {
-                    Block.blocksList[blockID].onBlockPlacedOnSide(world, blockX, blockY, blockZ, side, xPlaced, yPlaced);
+                    Blocks.blocksList[blockID].onBlockPlacedOnSide(world, blockX, blockY, blockZ, side, xPlaced, yPlaced);
                 } else {
-                    Block.blocksList[blockID].onBlockPlacedByMob(world, blockX, blockY, blockZ, side, player, xPlaced, yPlaced);
+                    Blocks.blocksList[blockID].onBlockPlacedByMob(world, blockX, blockY, blockZ, side, player, xPlaced, yPlaced);
                 }
                 world.playBlockSoundEffect(player, blockX + 0.5F, blockY + 0.5F, blockZ + 0.5F, block, EnumBlockSoundEffectType.PLACE);
                 itemstack.consumeItem(player);
diff --git a/src/main/java/net/minecraft/core/item/tool/ItemTool.java b/game/core/src/main/java/net/minecraft/core/item/tool/ItemTool.java
similarity index 96%
rename from src/main/java/net/minecraft/core/item/tool/ItemTool.java
rename to game/core/src/main/java/net/minecraft/core/item/tool/ItemTool.java
index ad9534899..84341cb2d 100644
--- a/src/main/java/net/minecraft/core/item/tool/ItemTool.java
+++ b/game/core/src/main/java/net/minecraft/core/item/tool/ItemTool.java
@@ -1,5 +1,6 @@
 package net.minecraft.core.item.tool;
 
+import net.minecraft.core.block.Blocks;
 import net.minecraft.core.data.tag.Tag;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.Mob;
@@ -46,7 +47,7 @@ public class ItemTool extends Item
 
 	@Override
 	public boolean onBlockDestroyed(World world, ItemStack itemstack, int i, int x, int y, int z, Side side, Mob mob) {
-		Block block = Block.blocksList[i];
+		Block block = Blocks.blocksList[i];
 		if(block != null) {
 			if(block.getHardness() > 0.0f || isSilkTouch()) {
 				itemstack.damageItem(1, mob);
diff --git a/src/main/java/net/minecraft/core/item/tool/ItemToolAxe.java b/game/core/src/main/java/net/minecraft/core/item/tool/ItemToolAxe.java
similarity index 93%
rename from src/main/java/net/minecraft/core/item/tool/ItemToolAxe.java
rename to game/core/src/main/java/net/minecraft/core/item/tool/ItemToolAxe.java
index 2e57468d3..6a9750bcf 100644
--- a/src/main/java/net/minecraft/core/item/tool/ItemToolAxe.java
+++ b/game/core/src/main/java/net/minecraft/core/item/tool/ItemToolAxe.java
@@ -2,6 +2,7 @@ package net.minecraft.core.item.tool;
 
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLog;
+import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.data.gamerule.GameRules;
 import net.minecraft.core.data.gamerule.TreecapitatorHelper;
@@ -31,7 +32,7 @@ public class ItemToolAxe extends ItemTool
     {
     	if(!world.isClientSide && world.getGameRuleValue(GameRules.TREECAPITATOR) && !player.isSneaking()) {
     		int id = world.getBlockId(x, y, z);
-    		if(Block.getBlock(id) instanceof BlockLog) {
+    		if(Blocks.getBlock(id) instanceof BlockLog) {
             	return !new TreecapitatorHelper(world, x, y, z, player).chopTree();
     		}
     	}
diff --git a/src/main/java/net/minecraft/core/item/tool/ItemToolShovel.java b/game/core/src/main/java/net/minecraft/core/item/tool/ItemToolShovel.java
similarity index 96%
rename from src/main/java/net/minecraft/core/item/tool/ItemToolShovel.java
rename to game/core/src/main/java/net/minecraft/core/item/tool/ItemToolShovel.java
index 84e91426a..efbd496a2 100644
--- a/src/main/java/net/minecraft/core/item/tool/ItemToolShovel.java
+++ b/game/core/src/main/java/net/minecraft/core/item/tool/ItemToolShovel.java
@@ -41,7 +41,7 @@ public class ItemToolShovel extends ItemTool
         if(side != Side.BOTTOM && blockAbove == 0 && (blockId == Blocks.GRASS.id || blockId == Blocks.DIRT.id || blockId == Blocks.GRASS_RETRO.id || blockId == Blocks.FARMLAND_DIRT.id))
         {
             Block block = Blocks.PATH_DIRT;
-            world.playBlockSoundEffect(entityplayer, blockX + 0.5F, blockY + 0.5F, blockZ + 0.5F, Block.blocksList[blockId], EnumBlockSoundEffectType.PLACE);
+            world.playBlockSoundEffect(entityplayer, blockX + 0.5F, blockY + 0.5F, blockZ + 0.5F, Blocks.blocksList[blockId], EnumBlockSoundEffectType.PLACE);
             if (!world.isClientSide) {
                 world.setBlockWithNotify(blockX, blockY, blockZ, block.id);
                 itemstack.damageItem(1, entityplayer);
diff --git a/src/main/java/net/minecraft/core/item/tool/ItemToolSword.java b/game/core/src/main/java/net/minecraft/core/item/tool/ItemToolSword.java
similarity index 98%
rename from src/main/java/net/minecraft/core/item/tool/ItemToolSword.java
rename to game/core/src/main/java/net/minecraft/core/item/tool/ItemToolSword.java
index 1e820d7a4..7289f11c9 100644
--- a/src/main/java/net/minecraft/core/item/tool/ItemToolSword.java
+++ b/game/core/src/main/java/net/minecraft/core/item/tool/ItemToolSword.java
@@ -43,7 +43,7 @@ public class ItemToolSword extends Item
     @Override
     public boolean onBlockDestroyed(World world, ItemStack itemstack, int i, int x, int y, int z, Side side, Mob mob)
     {
-        Block block = Block.blocksList[i];
+        Block block = Blocks.blocksList[i];
         if(block != null) {
             if(block.getHardness() > 0.0f || isSilkTouch()) {
                 itemstack.damageItem(2, mob);
diff --git a/src/main/java/net/minecraft/core/net/command/arguments/ArgumentTypeBlock.java b/game/core/src/main/java/net/minecraft/core/net/command/arguments/ArgumentTypeBlock.java
similarity index 96%
rename from src/main/java/net/minecraft/core/net/command/arguments/ArgumentTypeBlock.java
rename to game/core/src/main/java/net/minecraft/core/net/command/arguments/ArgumentTypeBlock.java
index f6af6ba89..c1c7ec628 100644
--- a/src/main/java/net/minecraft/core/net/command/arguments/ArgumentTypeBlock.java
+++ b/game/core/src/main/java/net/minecraft/core/net/command/arguments/ArgumentTypeBlock.java
@@ -7,6 +7,7 @@ import com.mojang.brigadier.exceptions.CommandSyntaxException;
 import com.mojang.brigadier.suggestion.Suggestions;
 import com.mojang.brigadier.suggestion.SuggestionsBuilder;
 import net.minecraft.core.block.Block;
+import net.minecraft.core.block.Blocks;
 import net.minecraft.core.net.command.helpers.BlockArgumentParser;
 import net.minecraft.core.net.command.helpers.BlockInput;
 import net.minecraft.core.net.command.util.CommandHelper;
@@ -40,7 +41,7 @@ public class ArgumentTypeBlock implements ArgumentType<BlockInput> {
         } catch (CommandSyntaxException ignored) {}
         return parser.fillSuggestions(builder, suggestionsBuilder -> {
             String remaining = suggestionsBuilder.getRemaining().toLowerCase(Locale.ROOT);
-            for (Block block : Block.blocksList) {
+            for (Block block : Blocks.blocksList) {
                 if (block == null) continue;
                 CommandHelper.getStringToSuggest(block.namespaceID.toString(), remaining).ifPresent(suggestionsBuilder::suggest);
             }
